#!/usr/bin/perl -Tw

#   Copyright (C) 2001-2002 Fernando Gomes
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
#   USA

use strict;
use DBI;

$ENV{PATH} = "/var/www/cgi-bin/catalogo:/bin";

# Variabel definition
my $TITLE = 'Catlogo NSK';
my $BGCOLOR = "#E8E8E8";
my $TEXT = "#000000";
my $LINK = "#0000FF";
my $VLINK = "#FF0000";
my $user = $ENV{"REMOTE_USER"};
my $program_version = `cat ./version`;
my $last_update = `cat ./last_update`;
my $news = `cat ./news`;
my $vars = "";
my $operation = "";
my @all_vars_splitted;
my $date = `date`;
my $admin = "nocturno";

#####
# Database information

my $db_ip = "localhost";
my $db_name = "catalogo";
my $db_user = "root";
my $db_password = "my_passwd";

#####

# Sub - Determine the method (POST, GET) 
method();

# Subs the + character for spaces
$vars =~ s/\+/ /g; # substituir '+' por espaos
#($operation, $resto) = split(/\&/, $vars); # what operations ?
($operation, @all_vars_splitted) = split(/\&/, $vars); # what operations ?
if ($operation) {
	# substituir sequencias hexadecimais
	$operation =~ s/%([0-9A-F][0-9A-F])/pack("c", hex($1))/ge;
	($_, $operation) = split(/=/, $operation); # what operations 
} else {
	$operation = "";
}

# Sub - Init the HTML code
html_begin();

# Dispatcher
if (!$operation || $operation eq "main") {
	main_form();
} elsif ($operation eq "cd_search") {
	cd_search();
} elsif ($operation eq "cd_details") {
	cd_details();
} elsif ($operation eq "cd_nodetails") {
	cd_nodetails();
} elsif ($operation eq "cd_insert") {
	cd_insert();
} elsif ($operation eq "insert_new_cd") {
	insert_new_cd();
} elsif ($operation eq "cd_change") {
	cd_change();
} elsif ($operation eq "cd_update") {
	cd_update();
} elsif ($operation eq "cd_ihaveto") {
	cd_ihaveto();
} elsif ($operation eq "send_mail") {
	send_mail();
} elsif ($operation eq "view_logs") {
	view_logs();
} elsif ($operation eq "delete_logs") {
	delete_logs();
} else {
	invalid_operation();
}

if ($operation ne "send_mail") {
	#Sub - Ends the HTML Code
	html_end();
}

######################################
########### SUBS
######################################

############################################################
# Determine the method
sub method {

	#
	# Determinar mtodo: GET, POST, ...
	#
	if ($ENV{REQUEST_METHOD} eq "GET") {
		$vars = $ENV{QUERY_STRING};
	} elsif ($ENV{REQUEST_METHOD} eq "POST") {
	        read(STDIN, $vars, $ENV{CONTENT_LENGTH}) or print "Problema a ler dados";
	} else {
	        print "Mtodo no suportado";
	}
}


############################################################
# Init the html code
sub html_begin {

print <<__HTML_BEGIN__;
Content-Type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"> 
<html>
 <head>
 	<title>$TITLE</title>
	<link rev=MADE href="mailto:fapg\@nsk.yi.org">
	<meta http-equiv="content-type" content="text/html;charset=iso-8859-1">
	<meta name="Copyright" content="&copy; 2001, NSK Group">
	<meta name="Author" content="Fernando A. P. Gomes">
	<script language="JavaScript">
	<!--
	// Hide script from old browsers
		function Item(url) {
			newWindow = window.open(url , "newGebruikersnaamWin", "width=520,height=420,left=20,top=20,resizable=no,menubar=no,directories=no,toolbar=no,scrollbars=yes")
		}
	// End hiding script from old browsers
	// -->
	</script>
 </head>
 <!--Cor de fundo e inicio do HTML-->
 <body bgcolor="$BGCOLOR" text="$TEXT" link="$LINK" vlink="$VLINK">
	<a name="TOP"></a>
	<br>
	<center>
		<h1><i>Catlogo NSK - Verso $program_version</i></h1>
	</center>
__HTML_BEGIN__

}


############################################################
# End the html code
sub html_end {

print <<__HTML_END__;
	<br><br><hr>
	<table align="left">
		<tr>
			<td align="left" width="32%">
				<font size="1">
					<a href="mailto:nocturno\@nsk.yi.org">Novas Ideias</a><br>
					(c) <a href="http://nsk.yi.org">NSK</a>, 2001<br>
					Script actualizada a ltima vez em $last_update<br>
					<a href="catalogo.pl?operacao=view_logs">Logs</a>
				</font>
			</td>
			<td align="center" witdth="50%">
				<font size="2">
					<a href="catalogo.pl">[Pgina Inicial]</a>
					<a href="catalogo.pl?operacao=cd_insert">[Inserir Novo CD]</a>
					<a href="catalogo.pl?operacao=cd_search">[Procurar CD Existente]</a>
				</font>
			</td><td width="30%" align="right">
				<p align="right">
					<form name="quick_search">
						<input type="hidden" name="operacao" value="cd_nodetails">
						<font size="2">Procura Rpida: <input type="text" name="any_field" size="9"></font>
						<input type="image" src="/catalogo/go.gif" name="search" alt="Procurar" border="0">
					</form>
				</p>
			</td>
		</tr>
	</table>
 </body>
</html>
__HTML_END__
}


############################################################
# Main form, catalogo main page
sub main_form {

	print "\t<br><p>\n";
	print "\t\t	<b>Bem Vindo $user, $date</b>\n";
	news();
	formulario();
	last_cds_inserted();
}


############################################################
# Form from the Main page
sub formulario {
	
print qq {
	<br>
	<form name="operacao">
		<table>
			<tr>
				<td>
					<select name="operacao"> <!--# method="post" -->
						<option label="insert" value="cd_insert">Inserir um Novo CD</option>
						<option label="search" value="cd_search">Procurar um CD j existente</option>
					</select>
				</td>
			</tr>
		</table><table>
			<tr>
				<td>
					<input type="submit" value="Submeter">
					<input type="reset" value="Limpar">
				</td>
			</tr>
		</table>
	</form>
}
}


#############################################################
# Show teh news
sub news {

print qq {
        <p align="center">
		<font size="5"><B>Notcias</b></font>
		<br><br>
		$news
	</p>
}
}


#############################################################
# See the last 10 cds, inserted in the database
sub last_cds_inserted {
	my ($dbh, $sth);
	my @line;

	print "\t<p align=\"center\">\n";
	print "\t\t<font size=\"5\">ltimos 10 CDs inseridos na Base de Dados</font><br>\n";

	#opens the connection to the database
	$dbh = DBI->connect("dbi:mysql:$db_name:$db_ip", "$db_user", "$db_password") or die "Connection: $DBI::errstr";

	#gets the last date of the last cd insert in the database
$sth = $dbh->prepare(<<"__LAST_DATE__") or die "Preparing: ", $dbh->errstr;
        SELECT Insert_Date FROM cd_desc ORDER BY cd_id DESC LIMIT 1
__LAST_DATE__
	#execute the last query
	$sth->execute or die "Executing: ", $sth->errstr;

	@line = $sth->fetchrow_array();
	print "\t<center>ltima insero: <i>$line[0]</i></center><br><br>\n";

	#gets the last 10 cds inserted in the database
$sth = $dbh->prepare(<<"__LAST_CDS__") or die "Preparing: ", $dbh->errstr;
        SELECT Program_Name, Owner FROM cd_desc ORDER BY cd_id DESC LIMIT 10
__LAST_CDS__
	#execute the last query
	$sth->execute or die "Executing: ", $sth->errstr;

	print "\t<center><table border=\"1\">\n";
	print "\t\t<tr>\n";
	print "\t\t\t<th>Nome do Programa/Video</th>\n";
	print "\t\t\t<th>Donos</th>\n";
	print "\t\t\t<th>Ver detalhes</th>\n";
	print "\t\t\t<th>Alterar Informao</th>\n";
	print "\t\t\t<th>Novo Dono</th>\n";
	print "\t\t</tr>\n";

	while (@line = $sth->fetchrow_array()) {

print <<__LAST_10_CDS__;
			<tr>
				<td align="left">$line[0]</td>
				<td align="center">$line[1]</td>
					<!-- Is Rong, but is the way to work well with IE ans netscape-->
					<form name="cd_details"> <!-- method="post">-->
				<td align="center">
						<input type="hidden" name="operacao" value="cd_details">
						<input type="hidden" name="program_name" value="$line[0]">
						<input type="submit" value="Detalhes">
				</td>
					</form>
					<form name="cd_change"><!--# method="post">-->
				<td align="center">
						<input type="hidden" name="operacao" value="cd_change">
						<input type="hidden" name="program_name" value="$line[0]">
						<input type="submit" value="Alterar">
				</td>
					</form>
					<form name="ihaveto">
				<td align="center">
					<input type="hidden" name="operacao" value="cd_ihaveto">
					<input type="hidden" name="program_name" value="$line[0]">
					<input type="submit" value="Adicionar">
				</td>
					</form>
			</tr>
__LAST_10_CDS__

	} #while ends

	print "\t</table></center>\n";
	$sth->finish();
	$dbh->disconnect;
}


#############################################################
# Search a CD in the DataBase
sub cd_search {

	# insert into teh table logs
	insert_logs($user, $date, "cd_search", "", "");

print <<__SEARCH_HTML__;
	<i>PROCURAR UM CD EXISTENTE</i><br><br>
	<form name="cd_nodetails"><!-- method="post">-->
	<input type="hidden" name="operacao" value="cd_nodetails">
		<table>
			<tr>
<!--				<th align="left">Procurar por Qualquer Campo:</th>
				<td><input type="text" name="any_field" size="50"></td>
			</tr><tr>-->
				<th align="left">Procurar por Nome do Programa/Video:</th>
				<input type="hidden" name="any_field" size="50">
				<td><input type="text" name="program_name" size="50"></td>
			</tr><tr>
				<th align="left">Procurar por Quem Inseriu:</th>
				<td><input type="text" name="insert_name" size="50"></td>
			</tr><tr>
				<th align="left">Procurar por Categoria:</th>
				<td>
					<select name="category">
						<option label="Filmes">Filmes</option>
						<option label="Jogos">Jogos</option>
						<option label="Programas">Programas</option>
						<option label="Musicas">Musicas</option>
					</select>
				</td>
			</tr><tr>
				<th align="left">Procurar por Plataforma:</th>
				<td>
					<select name="plataform">
						<option label="Todas">Todas</option>
						<option label="Linux">Linux</option>
						<option label="Windows">Windows</option>
					</select>
				</td>
			</tr><tr>
				<th align="left">Procurar por Tamanho:</th>
				<td><input type="text" name="size" size="50"></td>
			</tr><tr>
				<th align="left">Procurar por Verso:</th>
				<td><input type="text" name="version" size="50"></td>
			</tr><tr>
				<th align="left">Procurar por Durao:</th>
				<td><input type="text" name="duration" size="50"></td>
			</tr><tr>
				<th align="left">Procurar por Donos:</th>
				<td><input type="text" name="owner" size="50"></td>
			</tr><tr>
				<th align="left">Procurar por Observaes:</th>
				<td><input type="text" name="observations" size="50"></td>
			</tr>
		</table><br>
		<table>
			<tr>
				<td>Ordernar por
					<select name="order">
						<option label="Name" value="name_cres">Nome (Crescente)</option>
						<option label="Name" value="name_desc">Nome (Decrescente)</option>
						<option label="Insert" value="Insert_cres">Insero (Crescente)</option>
						<option label="Insert" value="Insert_desc">Insero (Decrescente)</option>
					</select>
				</td><td>
					<input type="checkbox" name="with_category" value="yes">Procurar com categoria
				</td><td>
					<input type="checkbox" name="with_plataform" value="yes">Procurar com plataform
				</td><td>
					<input type="checkbox" name="exact_match" value="yes">Procurar com <i>Exact Match</i>
				</td>
			</tr>
		</table>
		<br><br>
		<table align="left">
			<tr>
				<td><input type="submit" value="Procurar"></td>
				<td><input type="reset" value="Limpar"></td>
			</tr>
		</table>
	</form>
	<p align="right">
		<a href="javascript:Item('help_search.pl')">Ajuda</a>
	</p>
__SEARCH_HTML__
}


#############################################################
# Give here the data to  Insert new CD in the DataBase
sub cd_insert {

	# insert into teh table logs
	insert_logs($user, $date, "cd_insert", "", "");

print qq {
	<i>INSERIR UM NOVO CD</i><br><br>
	<form name="insert_new_cd">
		<input type="hidden" name="operacao" value="insert_new_cd">
		<table border="1">
			<tr>
				<th align="left">Nome do Programa/Video:</th>
				<td>
					<input type="text" name="program_name" size="25">
					(
					<select name="program_name_type">
						<option label="empty"></option>
						<option label="DVDrip.DivX">DVDrip.DivX</option>
						<option label="DVDrip.Video CD">DVDrip.Video CD</option>
						<option label="VHS.Video CD">VHS.Video CD</option>
						<option label="VHS.DivX">VHS.DivX</option>
						<option label="VHS.asf">VHS.asf</option>
						<option label="Cam.DivX">Cam.DivX</option>
						<option label="Cam.asf">Cam.asf</option>
					</select>
					)
				</td>
			</tr><tr>
				<th align="left">Insero feita por:</th>
				<td>$user<input type="hidden" name="insert_name" value="$user"></td>
			</tr><tr>
				<th align="left">Data de Insero:</th>
				<td>$date<input type="hidden" name="insert_date" value="$date"></td>
			</tr><tr>
				<th align="left">Categoria:</th>
				<td>
					<select name="category">
						<option label="Filmes">Filmes</option>
						<option label="Jogos">Jogos</option>
						<option label="Programas">Programas</option>
						<option label="Musicas">Musicas</option>
					</select>
				</td>
			</tr><tr>
				<th align="left">Plataforma:</th>
				<td>
					<select name="plataform">
						<option label="Todas">Todas</option>
						<option label="Linux">Linux</option>
						<option label="Windows">Windows</option>
					</select>
				</td>
			</tr><tr>
				<th align="left">Tamanho:</th>
				<td>
					<select name="size">
						<option label="1 CD">1 CD</option>
						<option label="2 CDs">2 CDs</option>
						<option label="3 CDs">3 CDs</option>
						<option label="4 CDs">4 CDs</option>
						<option label="5 CDs">5 CDs</option>
						<option label="6 CDs">6 CDs</option>
						<option label="7 CDs">7 CDs</option>
						<option label="8 CDs">8 CDs</option>
						<option label="9 CDs">9 CDs</option>
						<option label="1 DVD">1 DVD</option>
						<option label="2 DVDs">2 DVDs</option>
					</select>
					-
					<select name="size_minutos">
						<option label="74 Minutos">74 Minutos</option>
						<option label="80 Minutos">80 Minutos</option>
						<option label="90 Minutos">90 Minutos</option>
						<option label="DVD">DVD</option>
					</select>
				</td>
			</tr><tr>
				<th align="left">Verso:</th>
				<td><input type="text" name="version" size="50"></td>
			</tr><tr>
				<th align="left">Durao:</th>
				<td><input type="text" name="duration" size="50"></td>
			</tr><tr>
				<th align="left">Data de lanamento:</th>
				<td><input type="text" name="launch_year" size="50"></td>
<!--			</tr><tr>
				<th align="left">Ficheiro a anexar:</th>
				<td><input type="file" name="file_attach" size="39"></td>
			</tr><tr>
				<th align="left">Poster:</th>
				<td><input type="file" name="poster" size="39"></td>-->
			</tr><tr>
				<th align="left">Observaes:</th>
				<td><textarea wrap="virtual" cols="47" rows="10" name="observations"></textarea>
				<!--<input type="text" name="observations" size="50">--> </td>
			</tr>
		</table>
		<br>
		<input type="submit" value="Submeter">
		<input type="reset" value="Anular">
	</form>
			<!--<form method="post" enctype="multipart/form-data" action="upload.pl">
				Ficheiro a anexar:
				<input type="file" name="file_attach" size="39">
				<input type="submit" value="Upload">
			</form>-->
	<p align="right">
		<a href="javascript:Item('help_insert.pl')">Ajuda<a>
	</p>
}

}

#############################################################
# Insert new CD in the DataBase
sub insert_new_cd {
	my ($dbh, $sth);
	my @line;
	my %fields;
	my ($temp1, $temp2, $i);
	my $ok_or_ko = "ko";
	my $force = 0;
	my ($prog_name, $ins_name, $ins_date, $owner);
	my $first_time_here = 1;

	#my $buffer;
	#my $upath = "/var/www/cgi-bin/catalog/uploads/";
	#my $tempfile = $upath . $ENV{'REMOTE_ADDR'};
	#my $tempfile = $upath . "teste";

	#print STDERR %ENV;
	#print STDERR "\n\n\nISTO: $ENV{'CONTENT_LENGTH'}\n";;
	#read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	#open (FH,">$tempfile");
	#print STDERR "BUFFER: $buffer\n";
	#print FH $buffer;
	#close (FH);


	for ($i	= 0; $i <= 13; $i++) {
		#splits the variables
		if ($all_vars_splitted[$i]) {
			($temp1, $temp2) = split(/=/, $all_vars_splitted[$i]);
			#change the hexa characters
			$temp1 =~ s/%([0-9A-F][0-9A-F])/pack("c", hex($1))/ge;
			$temp2 =~ s/%([0-9A-F][0-9A-F])/pack("c", hex($1))/ge;
			$fields{$temp1} = $temp2;
		}
	}

	#joins the promgram name to a DVDrip, for example, in the case if the cd is a video
	if ($fields{program_name_type}) {
		$fields{program_name} = join('', $fields{program_name}, " (", $fields{program_name_type}, ")");
	}
	#joins the 1 CD to the 74 Minutes, for example
	#print STDERR "SIZE: $fields{size}, MINUTOS: $fields{size_minutos}";
	$fields{size} = join(' - ', $fields{size}, $fields{size_minutos});

	#verifica se todos os campos obrigatorios estao presentes
	if (($fields{program_name} ne "") && ($fields{category} ne "") && ($fields{plataform} ne "") && ($fields{size} ne "")) {
		$ok_or_ko = "ok";
	}

	#see if the insert is forced or not
	if ($fields{force}) {
		# insert into teh table logs
		insert_logs($user, $date, "insert_new_cd", "", "$fields{program_name} CD Force Enter");
		insert_in_database($ok_or_ko, $fields{program_name}, $fields{insert_name}, $fields{insert_date}, $fields{category}, $fields{plataform}, $fields{size}, $fields{version}, $fields{duration}, $fields{observations}, $fields{launch_year}, $fields{poster}, $fields{file_attach});
	} else {

		#opens the connection to the database
		$dbh = DBI->connect("dbi:mysql:$db_name:$db_ip", "$db_user", "$db_password") or die "Connection: $DBI::errstr";
		#finds a like CD case this exists
$sth = $dbh->prepare(<<"__VERIFIES__") or die "Preparing: ", $dbh->errstr;
        SELECT Program_Name, Insert_Name, Insert_Date, Owner FROM cd_desc WHERE Program_Name LIKE "\%$fields{program_name}\%" ORDER BY Program_Name
__VERIFIES__
		#execute the last query
		$sth->execute or die "Executing: ", $sth->errstr;

		while (@line = $sth->fetchrow_array()) {
			$prog_name = $line[0];
			$ins_name = $line[1];
			$ins_date = $line[2];
			$owner = $line[3];

			if ($ins_name) {
				if ($first_time_here) {
					print "\t<br><br><center>\n";
					print "\t<i>EXISTEM CDs IGUAIS/PARECIDOS COM O QUE EST A TENTAR INSERIR!</i>\n";
					print "\t<br><br><br>\n";
					print "\t<table border=\"1\">\n";
					print "\t\t<tr>\n";
					print "\t\t\t<th>Nome do Programa/Video</th>\n";
					print "\t\t\t<th>Insero feita por</th>\n";
					print "\t\t\t<th>Insero feita em</th>\n";
					print "\t\t\t<th>Ver detalhes</th>\n";
					print "\t\t\t<th>Adicionar Dono</th>\n";
					print "\t\t<tr>\n";
					$first_time_here = 0;
				}

				#dump to HTML
print qq {
		<tr>
			<td>
				$prog_name
			</td><td align="center">
				$owner
			</td><td align="center">
				$ins_date
			</td>
				<form name="cd_details"><!--method="post">-->
			<td align="center">
				<input type="hidden" name="operacao" value="cd_details">
				<input type="hidden" name="program_name" value="$prog_name">
				<input type="submit" value="Detalhes">
			</td>
				</form>
				<form name="cd_ihaveto"><!--method="post">-->
			<td align="center">
				<input type="hidden" name="operacao" value="cd_ihaveto">
				<input type="hidden" name="program_name" value="$prog_name">
				<input type="submit" value="Adicionar">
			</td>
				</form>
		</tr>
}

			}
		}

		$sth->finish();
		$dbh->disconnect;

		if ($ins_name) {
			# insert into teh table logs
			insert_logs($user, $date, "insert_new_cd", "", "$fields{program_name} CD Exists");

print <<__FORCE_INSERT__;
	</table>
	</center><br>
	<p>Deseja inserir o seu mesmo assim?</p>
	<table>
		<tr>
			<td>
				<form name="force_insert">
					<input type="hidden" name="operacao" value="insert_new_cd">
					<input type="hidden" name="program_name" value="$fields{program_name}">
					<input type="hidden" name="insert_name" value="$fields{insert_name}">
					<input type="hidden" name="insert_date" value="$fields{insert_date}">
					<input type="hidden" name="category" value="$fields{category}">
					<input type="hidden" name="plataform" value="$fields{plataform}">
					<input type="hidden" name="size" value="$fields{size}">
					<input type="hidden" name="version" value="$fields{version}">
					<input type="hidden" name="duration" value="$fields{duration}">
					<input type="hidden" name="observations" value="$fields{observations}">
					<input type="hidden" name="force" value="1">
					<input type="submit" value="Inserir">
				</form>
			</td><td>
				<form name="main">
					<input type="hidden" name="operacao" value="main"> 
					<input type="submit" value="Cancelar">
				</form>
	</table>
__FORCE_INSERT__

		} else {
			# insert into teh table logs
			insert_logs($user, $date, "insert_new_cd", "", "$fields{program_name} it's pacific");
	#		print STDERR "$fields{launch_year}, $fields{poster}, $fields{file_attach}\n";
			insert_in_database($ok_or_ko, $fields{program_name}, $fields{insert_name}, $fields{insert_date}, $fields{category}, $fields{plataform}, $fields{size}, $fields{version}, $fields{duration}, $fields{observations}, $fields{launch_year}, $fields{poster}, $fields{file_attach});
		}
	}
}


#############################################################
# Inserts a CD in the DataBase
sub insert_in_database {
	my ($dbh, $sth);
	my @line;
	my ($ok_or_ko, $program_name, $insert_name, $insert_date, $category, $plataform, $size, $version, $duration, $observations, $launch_year) = @_; #, $poster, $file_attach) = @_;

	#trata das "
	$observations =~ s/\"/\\\"/g;

	if ($ok_or_ko eq "ok") {

		#opens the connection to the database
		$dbh = DBI->connect("dbi:mysql:$db_name:$db_ip", "$db_user", "$db_password") or die "Connection: $DBI::errstr";

		#insert a new cd in the database a like CD case this exists
$sth = $dbh->prepare(<<"__INSERT_NEW_CD__") or die "Preparing: ", $dbh->errstr;
	INSERT INTO cd_desc (Program_Name, Insert_Name, Insert_Date, Category, Plataform, Size, Version, Duration, Owner, Observations, Launch_year)
	VALUES ("$program_name", "$insert_name", "$insert_date", "$category", "$plataform", "$size", "$version", "$duration", "$user", "$observations", "$launch_year")
__INSERT_NEW_CD__

		$sth->execute or die "Executing: ", $sth->errstr;

		#gets the last date of the last cd insert in the database
$sth = $dbh->prepare(<<"__LAST_CD_ID__") or die "Preparing: ", $dbh->errstr;
        SELECT CD_ID FROM cd_desc ORDER BY cd_id DESC LIMIT 1
__LAST_CD_ID__
		#execute the last query
		$sth->execute or die "Executing: ", $sth->errstr;

		# insert into teh table logs
		@line = $sth->fetchrow_array();
		insert_logs($user, $date, "insert_in_database", $line[0], "$program_name inserted in database!");

		$sth->finish();
		$dbh->disconnect;

		html_sucess("insert");
	} else {
		html_missing_data("insert");
	}

}

#############################################################
# Show the CD details
sub cd_details {
	my ($dbh, $sth);
	my @line;
	my %fields;
	my ($temp1, $temp2, $i);

	for ($i	= 0; $i <= 1; $i++) {
		#splits the variables
		if ($all_vars_splitted[$i]) {
			($temp1, $temp2) = split(/=/, $all_vars_splitted[$i]);
			#change the hexa characters
			$temp1 =~ s/%([0-9A-F][0-9A-F])/pack("c", hex($1))/ge;
			$temp2 =~ s/%([0-9A-F][0-9A-F])/pack("c", hex($1))/ge;
			$fields{$temp1} = $temp2;
		}
	}

	#opens the connection to the database
	$dbh = DBI->connect("dbi:mysql:$db_name:$db_ip", "$db_user", "$db_password") or die "Connection: $DBI::errstr";
	#gets the CD to modify
$sth = $dbh->prepare(<<"__CD_DETAILS__") or die "Preparing: ", $dbh->errstr;
        SELECT Program_Name, Insert_Name, Change_Name, Insert_Date, Change_Date, Category, Plataform, Size, Version, Duration, Owner, Observations, CD_ID, Launch_year, Poster, File_attach FROM cd_desc WHERE Program_Name = "$fields{program_name}"
__CD_DETAILS__
	#execute the last query
    $sth->execute or die "Executing: ", $sth->errstr;

	while (@line = $sth->fetchrow_array()) {
		# insert into teh table logs
		insert_logs($user, $date, "cd_details", "$line[12]", "$fields{program_name} view details");

print <<__HTML_SHOW_RESULTS__;
	<br>
	<p align="center">
		<i>DETALHES DO CD - $line[0]</i>
	</p><br>
	<center>
		<table border="1">
			<tr>
				<th algin="left">Nome do Programa/Video:</th>
				<td>$line[0]</td>
			</tr><tr>
				<th algin="left">Insero feita por:</th>
				<!--<td><a href="mailto:$line[1]\@nsk.yi.org">$line[1]</a></td>-->
__HTML_SHOW_RESULTS__
		$line[0] =~s/'/%1/g;
		print "\t\t\t<td><a href=\"javascript:Item('catalogo.pl?operacao=send_mail&program_name=$line[0]&owner=$line[1]')\">$line[1]</a></td>\n";
		$line[0] =~s/%1/'/g;

		if ($line[2]) {
			print "\t\t</tr><tr>\n";
			print "\t\t\t<th algin=\"left\">Modificaes feitas por:</TH>\n";
			print "\t\t\t<td>$line[2]</td>\n";
			
		}
		print "\t\t</tr><tr>\n";
		print "\t\t\t<th algin=\"left\">Data de Insero:</TH>\n";
		print "\t\t\t<td>$line[3]</td>\n";
		if ($line[4]) {
			print "\t\t</tr><tr>\n";
			print "\t\t\t<th algin=\"left\">Modificado em:</TH>\n";
			print "\t\t\t<td>$line[4]</td>\n";
		}

print <<__HTML_SHOW_RESULTS__;
		</tr><tr>
			<th algin="left">Categoria:</TH>
			<td>$line[5]</td>
		</tr><tr>
			<th algin="left">Plataforma:</TH>
			<td>$line[6]</td>
		</tr><tr>
			<th algin="left">Tamanho:</TH>
			<td>$line[7]</td>
		</tr><tr>
__HTML_SHOW_RESULTS__
		if ($line[8]) {
			print "\t\t\t<th algin=\"left\">Verso:</TH>\n";
			print "\t\t\t<td>$line[8]</td>\n";
			print "\t\t</tr><tr>\n";
		}
		if ($line[9]) {
			print "\t\t\t<th algin=\"left\">Durao:</TH>\n";
			print "\t\t\t<td>$line[9]</td>\n";
			print "\t\t</tr><tr>\n";
		}
		if ($line[10]) {
			print "\t\t\t<th algin=\"left\">Donos:</TH>\n";
			print "\t\t\t<td>$line[10]</td>\n";
			print "\t\t</tr><tr>\n";
		}
		if ($line[13]) {
			print "\t\t\t<th algin=\"left\">Data de Lanamento:</TH>\n";
			print "\t\t\t<td>$line[13]</td>\n";
			print "\t\t</tr><tr>\n";
		}
		if ($line[15]) {
			print "\t\t\t<th algin=\"left\">File Attached:</TH>\n";
			print "\t\t\t<td>$line[15]</td>\n";
			print "\t\t</tr><tr>\n";
		}
		if ($line[14]) {
			print "\t\t\t<th algin=\"left\">Poster:</TH>\n";
			print "\t\t\t<td>$line[14]</td>\n";
			print "\t\t</tr><tr>\n";
		}
print <<__HTML_SHOW_RESULTS__;
			<th algin="left">Obervaes:</TH>
			<td>$line[11]</td>
		</tr>
	</table>
	<form name="cd_change">
		<input type="hidden" name="operacao" value="cd_change">
		<input type="hidden" name="program_name" value="$line[0]">
		<input type="submit" value="Modificar $line[0]">
	</form>
	</center>
	<br>
__HTML_SHOW_RESULTS__

	}

	$sth->finish();
	$dbh->disconnect;
}


#############################################################
# Show the CD details
sub cd_nodetails {
	my ($dbh, $sth);
	my @line;
	my %fields;
	my ($temp1, $temp2);
	my $exact_match = 0;
	my $nao_entrou = 1;
	my $i;
	my $order = "Program_Name";
	my $cd_id = 0;
	my $found_size = 0;

	for ($i	= 0; $i <= 13; $i++) {
		#splits the variables
		if ($all_vars_splitted[$i]) {
			($temp1, $temp2) = split(/=/, $all_vars_splitted[$i]);
			#change the hexa characters
			$temp1 =~ s/%([0-9A-F][0-9A-F])/pack("c", hex($1))/ge;
			$temp2 =~ s/%([0-9A-F][0-9A-F])/pack("c", hex($1))/ge;
			$fields{$temp1} = $temp2;
		}
	}

	if (!$fields{program_name}) {
		$fields{program_name} = "";
	}
	if (!$fields{insert_name}) {
		$fields{insert_name} = "";
	}
	if (!$fields{size}) {
		$fields{size} = "";
	}
	if (!$fields{version}) {
		$fields{version} = "";
	}
	if (!$fields{duration}) {
		$fields{duration} = "";
	}
	if (!$fields{observations}) {
		$fields{observations} = "";
	}
	if (!$fields{any_field}) {
		$fields{any_field} = "";
	}
	if (!$fields{with_category}) {
		$fields{category} = "";
	}
	if (!$fields{with_plataform}) {
		$fields{plataform} = "";
	}
	if ($fields{exact_match}) {
		$exact_match = 1;
	}

	#Select the order of ordenation
	if ($fields{order}) {
		if ($fields{order} eq "name_desc") {
			$order = "Program_Name DESC";
			$cd_id = 0;
		} elsif ($fields{order} eq "name_cres") {
			$order = "Program_Name";
			$cd_id = 0;
		} elsif ($fields{order} eq "Insert_desc") {
			$order = "CD_ID DESC";
			$cd_id = 1;
		} elsif ($fields{order} eq "Insert_cres") {
			$order = "CD_ID";
			$cd_id = 1;
		}
	} else {
		$order = "Program_Name";
	}

	#opens the connection to the database
	$dbh = DBI->connect("dbi:mysql:$db_name:$db_ip", "$db_user", "$db_password") or die "Connection: $DBI::errstr";
	if ($exact_match) {

$sth = $dbh->prepare(<<"__INSERT__") or die "Preparing: ", $dbh->errstr;
	SELECT Program_Name, Owner, CD_ID FROM cd_desc WHERE Program_Name = "$fields{program_name}"
__INSERT__

		# insert into teh table logs
		insert_logs($user, $date, "cd_nodetails", "", "Procura por Exact Match: $fields{program_name}");

	} else {
		if ($fields{any_field}) {
			
$sth = $dbh->prepare(<<"__SEARCH_BY_INSERT__") or die "Preparing: ", $dbh->errstr;
	SELECT Program_Name, Owner, CD_ID FROM cd_desc WHERE Program_Name LIKE "\%$fields{any_field}\%" OR Insert_Name LIKE "\%$fields{any_field}\%" OR Category LIKE "\%$fields{any_field}\%" OR Plataform LIKE "\%$fields{any_field}\%" OR Size LIKE "\%$fields{any_field}\%" OR Version LIKE "\%$fields{any_field}\%" OR Duration LIKE "\%$fields{any_field}\%" OR Owner LIKE "\%$fields{any_field}\%" OR Observations LIKE "\%$fields{any_field}\%" ORDER BY $order
__SEARCH_BY_INSERT__

		# insert into teh table logs
		insert_logs($user, $date, "cd_nodetails", "", "Procura por ANY FIELD: $fields{any_field}");

		} else {

$sth = $dbh->prepare(<<"__SEARCH_BY_INSERT__") or die "Preparing: ", $dbh->errstr;
	SELECT Program_Name, Owner, CD_ID FROM cd_desc WHERE Program_Name LIKE "\%$fields{program_name}\%" AND Insert_Name LIKE "\%$fields{insert_name}\%" AND Category LIKE "\%$fields{category}\%" AND Plataform LIKE "\%$fields{plataform}\%" AND Size LIKE "\%$fields{size}\%" AND Version LIKE "\%$fields{version}\%" AND Duration LIKE "\%$fields{duration}\%" AND Observations LIKE "\%$fields{observations}\%" ORDER BY $order
__SEARCH_BY_INSERT__

		# insert into teh table logs
		insert_logs($user, $date, "cd_nodetails", "", "Procura por: $fields{program_name}, $fields{insert_name},$fields{category}, $fields{plataform}, $fields{size}, $fields{version}, $fields{duration}, $fields{observations}");

		}
	}

	$sth->execute or die "Executing: ", $sth->errstr;
	
	print "\t<br><p align=\"center\"><i>FORAM ENCONTRADOS OS SEGUINTES CDs</i><br><p>\n";
	print "\t<center>\n";
	print "\t<table border=\"1\">\n";
	print "\t\t<tr>\n";
	print "\t\t\t<th>Nome do Programa/Video</th>\n";
	print "\t\t\t<th>Dono(s)</th>\n";
	print "\t\t\t<th>Ver detalhes</th>\n";
	print "\t\t\t<th>Alterar Informao</th>\n";
	print "\t\t\t<th>Adicionar Dono</th>\n";
	print "\t\t</tr>\n";

	while (@line = $sth->fetchrow_array()) {
		$found_size++;
		print "\t\t<tr>\n";
		if ($cd_id) {
			print "\t\t\t<td align=\"left\">$line[2] - $line[0]</td>\n";
		} else {
			print "\t\t\t<td align=\"left\">$line[0]</td>\n";
		}

print <<__HTML_SHOW_RESULTS__
		<td align="center">$line[1]</td>
			<form name="show_details"><!--method="post">-->
		<td align="center">
			<input type="hidden" name="operacao" value="cd_details">
			<input type="hidden" name="program_name" value="$line[0]">
			<input type="submit" value="Detalhes">
		</td>
			</form>
			<form name="change">
		<td align="center">
			<input type="hidden" name="operacao" value="cd_change">
			<input type="hidden" name="program_name" value="$line[0]">
			<input type="submit" value="Alterar">
		</td>
			</form>
			<form name="ihaveto">
		<td align="center">
			<input type="hidden" name="operacao" value="cd_ihaveto">
			<input type="hidden" name="program_name" value="$line[0]">
			<input type="submit" value="Adicionar">
		</td>
			</form>
	</tr>
__HTML_SHOW_RESULTS__

	}

	print "\t</table>\n";
	print "\t<br><b>$found_size CDs NO TOTAL</b>\n";
	print "\t</center>\n";
	
	$sth->finish();
	$dbh->disconnect;

}

	
#############################################################
# Change a existing CD
sub cd_change {
	my ($dbh, $sth);
	my @line;
	my ($size, $size_minutos);
	my %fields;
	my ($temp1, $temp2, $i);
	my $cd1 = "";
	my $cd2 = "";
	my $cd3 = "";
	my $cd4 = "";
	my $cd5 = "";
	my $cd6 = "";
	my $cd7 = "";
	my $cd8 = "";
	my $cd9 = "";
	my $dvd1 = "";
	my $dvd2 = "";
	my $dvd = "";
	my $minutos74 = "";
	my $minutos80 = "";
	my $minutos90 = "";

	for ($i	= 0; $i <= 1; $i++) {
		#splits the variables
		if ($all_vars_splitted[$i]) {
			($temp1, $temp2) = split(/=/, $all_vars_splitted[$i]);
			#change the hexa characters
			$temp1 =~ s/%([0-9A-F][0-9A-F])/pack("c", hex($1))/ge;
			$temp2 =~ s/%([0-9A-F][0-9A-F])/pack("c", hex($1))/ge;
			$fields{$temp1} = $temp2;
		}
	}

	print "<br><p align=\"center\"><i>MODIFICAR CD - $fields{program_name}</i><br><p>\n";

	#opens the connection to the database
	$dbh = DBI->connect("dbi:mysql:$db_name:$db_ip", "$db_user", "$db_password") or die "Connection: $DBI::errstr";

	#gets the CD to modify
$sth = $dbh->prepare(<<"__CHANGE__") or die "Preparing: ", $dbh->errstr;
        SELECT Program_Name, Insert_Name, Change_Name, Insert_Date, Change_Date, Category, Plataform, Size, Version, Duration, Owner, Observations, launch_year, CD_ID  FROM cd_desc WHERE Program_Name = "$fields{program_name}"
__CHANGE__
	#execute the last query
	$sth->execute or die "Executing: ", $sth->errstr;

	while (@line = $sth->fetchrow_array()) {
		# insert into teh table logs
		insert_logs($user, $date, "cd_change", "$line[12]", "$fields{program_name} view to change.");

print <<__RESULT_HTML__;
	<center>
	<form name="cd_update">
		<input type="hidden" name="operacao" value="cd_update">
		<table border="1">
			<tr>
				<th align="left">Nome do Programa/Video:</th>
				<td><input type="hidden" name="program_name" value="$line[0]">
				<input type="text" name="prog_name" value="$line[0]" size="50">
					<!--(
					<select name="program_name_type">
						<option label="empty"></option>
						<option label="DVDrip.DivX">DVDrip.DivX</option>
						<option label="DVDrip.Video CD">DVDrip.Video CD</option>
						<option label="VHS.Video CD">VHS.Video CD</option>
						<option label="VHS.DivX">VHS.DivX</option>
						<option label="VHS.asf">VHS.asf</option>
						<option label="Cam.DivX">Cam.DivX</option>
						<option label="Cam.asf">Cam.asf</option>
					</select>
					)-->
				</td>
			</tr><tr>
				<th align="left">Insero feita por:</th>
				<td>$line[1]</td>
			</tr><tr>
				<th align="left">Data de Insero:</th>
				<td>$line[3]</td>
			</tr><tr>
				<th align="left">Categoria:</th>
				<td><input type="text" name="category" value="$line[5]" size="50"></td>
			</tr><tr>
				<th align="left">Plataforma:</th>
				<td><input type="text" name="plataform" value="$line[6]" size="50"></td>
			</tr><tr>
__RESULT_HTML__
#					<!--<input type="text" name="size" value="$line[7]" size="50">-->
		($fields{size}, $fields{size_minutos}) = split(/-/, $line[7]);
		#put the check in the html select option
		if ($fields{size} eq "1 CD ") {
			$cd1 = "selected";
		} elsif ($fields{size} eq "2 CDs ") {
			$cd2 = "selected";
		} elsif ($fields{size} eq "3 CDs ") {
			$cd3 = "selected";
		} elsif ($fields{size} eq "4 CDs ") {
			$cd4 = "selected";
		} elsif ($fields{size} eq "5 CDs ") {
			$cd5 = "selected";
		} elsif ($fields{size} eq "6 CDs ") {
			$cd6 = "selected";
		} elsif ($fields{size} eq "7 CDs ") {
			$cd7 = "selected";
		} elsif ($fields{size} eq "8 CDs ") {
			$cd8 = "selected";
		} elsif ($fields{size} eq "9 CDs ") {
			$cd9 = "selected";
		} elsif ($fields{size} eq "1 DVD ") {
			$dvd1 = "selected";
		} elsif ($fields{size} eq "2 DVDs ") {
			$dvd2 = "selected";
		} else {
			$cd1 = "selected";
		}

		if ($fields{size_minutos} eq " 74 Minutos") {
			$minutos74 = "selected";
		} elsif ($fields{size_minutos} eq " 80 Minutos") {
			$minutos80 = "selected";
		} elsif ($fields{size_minutos} eq " 90 Minutos") {
			$minutos90 = "selected";
		} elsif ($fields{size_minutos} eq " DVD") {
			$dvd = "selected";
		} else {
			$minutos74 = "selected";
		}

print <<__RESULT_HTML__;
				<th align="left">Tamanho:</th>
				<td>
					<select name="size">
						<option $cd1 label="1 CD">1 CD</option>
						<option $cd2 label="2 CDs">2 CDs</option>
						<option $cd3 label="3 CDs">3 CDs</option>
						<option $cd4 label="4 CDs">4 CDs</option>
						<option $cd5 label="5 CDs">5 CDs</option>
						<option $cd6 label="6 CDs">6 CDs</option>
						<option $cd7 label="7 CDs">7 CDs</option>
						<option $cd8 label="8 CDs">8 CDs</option>
						<option $cd9 label="9 CDs">9 CDs</option>
						<option $dvd1 label="1 DVD">1 DVD</option>
						<option $dvd2 label="2 DVDs">2 DVDs</option>
		
					</select>
					-
					<select name="size_minutos">
						<option $minutos74 label="74 Minutos">74 Minutos</option>
						<option $minutos80 label="80 Minutos">80 Minutos</option>
						<option $minutos90 label="90 Minutos">90 Minutos</option>
						<option $dvd label="DVD">DVD</option>
					</select>
				</td>
			</tr><tr>
				<th align="left">Verso:</th>
				<td><input type="text" name="version" value="$line[8]" size="50"></td>
			</tr><tr>
				<th align="left">Durao:</th>
				<td><input type="text" name="duration" value="$line[9]" size="50"></td>
			</tr><tr>
				<th align="left">Donos:</th>
__RESULT_HTML__
			if ($line[10]) {
				print "<td>$line[10]</td>";
#<input type=\"sumbit\" name=\"owner\" value=\"$line[10]\" size=\"50\"></td>";
			} else {
				print "<td>No existem donos adicionais,  uma cpia nica :)</td>";
			}
print <<__RESULT_HTML__;
			</tr><tr>
				<th align="left">Data de Lanamento:</th>
				<td><input type="text" name="launch_year" value="$line[12]" size="50"></td>
			</tr><tr>
				<th align="left">Observaes:</th>
				<td><!--<input type="text" name="observations" value="$line[11]" size="50">-->
					<textarea wrap="virtual" cols="38" rows="10" name="observations">$line[11]</textarea>
				</td>
			</tr>
		</table>
		<br>
		<input type="submit" value="Aceitar Modificaes">
	</form>
	</center>
__RESULT_HTML__

	}

	$sth->finish();
	$dbh->disconnect;
}


############################################################
# Updates the database
sub cd_update {
	my ($dbh, $sth);
	my @line;
	my %fields;
	my ($temp1, $temp2, $i);
	my $ok_or_ko = "ko";
	
	for ($i	= 0; $i <= 10; $i++) {
		#splits the variables
		if ($all_vars_splitted[$i]) {
			($temp1, $temp2) = split(/=/, $all_vars_splitted[$i]);
			#change the hexa characters
			$temp1 =~ s/%([0-9A-F][0-9A-F])/pack("c", hex($1))/ge;
			$temp2 =~ s/%([0-9A-F][0-9A-F])/pack("c", hex($1))/ge;
			$fields{$temp1} = $temp2;
		}
	}

	#trata das "
	$fields{observations} =~ s/\"/\\\"/g;

	# insert into teh table logs
	insert_logs($user, $date, "cd_update", "", "$fields{program_name} is updated!");

	#verifies if the needed fields are fill
	if (($fields{program_name} ne "") && ($fields{category} ne "") && ($fields{plataform} ne "") && ($fields{size} ne "")) {
                $ok_or_ko = "ok";
        } 

	#joins the 1 CD to the 74 Minutes, for example
	$fields{size} = join(' - ', $fields{size}, $fields{size_minutos});
	
	if ($ok_or_ko eq "ok") {
		#opens the connection to the database
		$dbh = DBI->connect("dbi:mysql:$db_name:$db_ip", "$db_user", "$db_password") or die "Connection: $DBI::errstr";

$sth = $dbh->prepare(<<"__UPDATE__") or die "Preparing: ", $dbh->errstr;
	UPDATE cd_desc SET Program_Name = "$fields{prog_name}", Change_Name = "$user", Change_Date = "$date", Category = "$fields{category}", Plataform = "$fields{plataform}", Size = "$fields{size}", Version = "$fields{version}", Duration = "$fields{duration}", Observations = "$fields{observations}", launch_year = $fields{launch_year} WHERE Program_Name = "$fields{program_name}"
__UPDATE__

		$sth->execute or die "Executing: ", $sth->errstr;
		$sth->finish();
		$dbh->disconnect;

		html_sucess("update");

	} else {
		html_missing_data("update");
	}
}


#############################################################
# When the operation do not exist
sub cd_ihaveto {
	my ($dbh, $sth);
	my %fields;
	my ($temp1, $temp2, $i);
	my @line;

	for ($i	= 0; $i <= 1; $i++) {
		#splits the variables
		if ($all_vars_splitted[$i]) {
			($temp1, $temp2) = split(/=/, $all_vars_splitted[$i]);
			#change the hexa characters
			$temp1 =~ s/%([0-9A-F][0-9A-F])/pack("c", hex($1))/ge;
			$temp2 =~ s/%([0-9A-F][0-9A-F])/pack("c", hex($1))/ge;
			$fields{$temp1} = $temp2;
		}
	}


	#opens the connection to the database
	$dbh = DBI->connect("dbi:mysql:$db_name:$db_ip", "$db_user", "$db_password") or die "Connection: $DBI::errstr";

$sth = $dbh->prepare(<<"__UPDATE__") or die "Preparing: ", $dbh->errstr;
	SELECT Owner, CD_ID FROM cd_desc WHERE Program_Name = "$fields{program_name}"
__UPDATE__

	$sth->execute or die "Executing: ", $sth->errstr;
	@line = $sth->fetchrow_array();

	if ($line[0]) {
		if ($line[0] =~ m/$user/i) {
			# insert into teh table logs
			insert_logs($user, $date, "cd_ihaveto", "$line[1]", "In $fields{program_name} owner already exists.");

			html_missing_data("ihaveto");
		} else {

$sth = $dbh->prepare(<<"__UPDATE__") or die "Preparing: ", $dbh->errstr;
	UPDATE cd_desc SET Owner = "$line[0], $user" WHERE Program_Name = "$fields{program_name}"
__UPDATE__

			$sth->execute or die "Executing: ", $sth->errstr;
			# insert into teh table logs
			insert_logs($user, $date, "cd_ihaveto", "$line[1]", "$fields{program_name} added owner!");

			html_sucess("update");
		}

	} else {

$sth = $dbh->prepare(<<"__UPDATE__") or die "Preparing: ", $dbh->errstr;
	UPDATE cd_desc SET Owner = "$user" WHERE Program_Name = "$fields{program_name}"
__UPDATE__

		$sth->execute or die "Executing: ", $sth->errstr;

		# insert into teh table logs
		insert_logs($user, $date, "cd_ihaveto", "$line[1]", "$fields{program_name} added owner!");

		html_sucess("update");
	}
	$sth->finish();
	$dbh->disconnect;
}


#############################################################
# Send a Mail to the User to get the CD
sub send_mail {
	my ($temp1, $temp2, $i);
	my %fields;
	my $texto;

	for ($i	= 0; $i <= 2; $i++) {
		#splits the variables
		if ($all_vars_splitted[$i]) {
			($temp1, $temp2) = split(/=/, $all_vars_splitted[$i]);
			#change the hexa characters
			$temp1 =~ s/%([0-9A-F][0-9A-F])/pack("c", hex($1))/ge;
			$temp2 =~ s/%([0-9A-F][0-9A-F])/pack("c", hex($1))/ge;
			$fields{$temp1} = $temp2;
		}
	}

	$fields{program_name} =~s/%1/'/g;

	# insert into teh table logs
	insert_logs($user, $date, "send_mail", "", "Requers the movie $fields{program_name} to $fields{owner}");

	$texto = "$user requesita o filme $fields{program_name} em $date";

print qq {
	<form action="./send_mail.pl" name="send_mail"><!--method="post">-->
		<table>
			<tr>
				<td>
					De:
				</td><td>
					<input type="text" name="mail_from" value="$user\@nsk.yi.org">
				</td>
			</tr><tr>
				<td>
					Para:
				</td><td>
					<input type="text" name="rcpt" value="$fields{owner}\@nsk.yi.org">
				</td>
			</tr><tr>
				<td>
					Assunto:
				</td><td>
					<!--<input type="text" name="subject" value="Catalogo: requesio">-->
					Catalogo: requesio
				</td>
			</tr><tr>
				<td>
					Mensagem:
				</td><td>
					<textarea wrap="virtual" cols="38" rows="10" name="mail">$texto</textarea>
				</td>
			<tr>
				<td>
					<!--<input type="submit" value="Enviar Mail">-->
					<a href="send_mail.pl?$user\@nsk.yi.org&$fields{owner}\@nsk.yi.org&$texto">Enviar Mail</a>
				</td>
			</tr>
		</table>
	</form>
}
}


#############################################################
# Coment the news
sub comment_news {
}


#############################################################
# When the operation do not exist
sub invalid_operation {
	print "<br><br><br><center><h1>Operao Invlida: $operation</h1></center>";

	# insert into teh table logs
	insert_logs($user, $date, "invalid_operation", "", "Invalid Operation: $operation");
}


#############################################################
# Shows the html language if the insert/update is ok
sub html_sucess {
	my $type;

	($type) = @_;

	if ($type eq "update") {
		print "\t<center><i>NOVO CD ALTERADO CORRECTAMENTE</i><center><br>\n";
	} elsif ($type eq "insert") {
		print "\t<center><i>NOVO CD INSERIDO CORRECTAMENTE</i><center><br>\n";
	}
print qq {
	<form name="main">
		<input type="hidden" name="operacao" value="main">
		<input type="submit" value="Voltar">
	</form>
}
}


#############################################################
# Shows the html language if the insert/update is not ok
sub html_missing_data {
	my $type;

	($type) = @_;

	if ($type eq "update") {
		print "\t<center><i>CD NO FOI ALTERADO CORRECTAMENTE - FALTAM DADOS</i><center><br>\n";

print qq {
	<form name="cd_update">
		<input type="hidden" name="operacao" value="cd_update">
		<input type="submit" value="Voltar">
	</form>
}

	} elsif ($type eq "insert") {
		print "\t<center><i>NOVO CD NO FOI INSERIDO- FALTAM DADOS</i><center><br>\n";

print qq {
	<form name="cd_insert">
		<input type="hidden" name="operacao" value="cd_insert">
		<input type="submit" value="Voltar">
	</form>
}
		
	} elsif ($type eq "ihaveto") {
		print "\t<center><i>DONO J EXISTENTE</i><center><br>\n";

print qq {
	<form name="main">
		<input type="hidden" name="operacao" value="main">
		<input type="submit" value="Voltar">
	</form>
}
		
	}
}


#############################################################
# Save ALL Logs :)
sub insert_logs {
	my ($dbh, $sth);
	my ($user_log, $date_log, $acceded_sub_log, $cd_change_id_log, $debug) = @_;
	chomp($date_log);

	#opens the connection to the database
	$dbh = DBI->connect("dbi:mysql:$db_name:$db_ip", "$db_user", "$db_password") or die "Connection: $DBI::errstr";

$sth = $dbh->prepare(<<"__INSERT_LOGS__") or die "Preparing: ", $dbh->errstr;
	INSERT INTO logs (User, Date, Acceded_Sub, CD_Change_id, Debug) 
	VALUES ("$user_log", "$date_log", "$acceded_sub_log", "$cd_change_id_log", "$debug")
__INSERT_LOGS__

	$sth->execute or die "Executing: ", $sth->errstr;
	
	$sth->finish();
	$dbh->disconnect;
}


#############################################################
# View ALL Logs :)
sub view_logs {
	my ($dbh, $sth);
	my @line;

	if ($user eq $admin) {
		# insert into teh table logs
		insert_logs($user, $date, "view_logs", "", "Logs view!");
		#opens the connection to the database
		$dbh = DBI->connect("dbi:mysql:$db_name:$db_ip", "$db_user", "$db_password") or die "Connection: $DBI::errstr";

$sth = $dbh->prepare(<<"__VIEW_LOGS__") or die "Preparing: ", $dbh->errstr;
	SELECT * FROM logs
__VIEW_LOGS__

		$sth->execute or die "Executing: ", $sth->errstr;

		print "\t<br><p align=\"center\"><i>LOGS</i><br><p>\n";
		print "\t<center>\n";
		print "\t<table border=\"1\">\n";
		print "\t\t<tr>\n";
		print "\t\t\t<th>Logs ID</th>\n";
		print "\t\t\t<th>Utilizador</th>\n";
		print "\t\t\t<th>Data</th>\n";
		print "\t\t\t<th>Funo Acedida</th>\n";
		print "\t\t\t<th>CD Modificado</th>\n";
		print "\t\t\t<th>Debug</th>\n";
		print "\t\t</tr>\n";

		while (@line = $sth->fetchrow_array()) {

print <<__HTML_SHOW_RESULTS__
		<tr>
			<td align="left">$line[0]</td>
			<td align="left">$line[1]</td>
			<td align="left">$line[2]</td>
			<td align="left">$line[3]</td>
			<td align="left">$line[4]</td>
			<td align="left">$line[5]</td>
		</tr>
__HTML_SHOW_RESULTS__

		}

		print "\t</table>\n";
		print "\t</center>\n";
		
		$sth->finish();
		$dbh->disconnect;
print qq {
	<center>
	<form name="main">
		<input type="hidden" name="operacao" value="delete_logs">
		<input type="submit" value="Apagar Logs">
	</form>
	</center>
}

	} else {
		# insert into teh table logs
		insert_logs($user, $date, "view_logs", "", "Try to view logs.");

print qq {
	<br><p align="center"><i>LOGS - ACESSO INTERDITO A $user</i><br><p>
	<center>
	<form name="main">
		<input type="hidden" name="operacao" value="main">
		<input type="submit" value="Voltar">
	</form>
	</center>
}

	}
}


#############################################################
# DELETE all logs
sub delete_logs {
	my ($dbh, $sth);
	my $force = 0;
	my ($temp1, $temp2);
	my %fields;
	my $i;

	for ($i	= 0; $i <= 2; $i++) {
		#splits the variables
		if ($all_vars_splitted[$i]) {
			($temp1, $temp2) = split(/=/, $all_vars_splitted[$i]);
			#change the hexa characters
			$temp1 =~ s/%([0-9A-F][0-9A-F])/pack("c", hex($1))/ge;
			$temp2 =~ s/%([0-9A-F][0-9A-F])/pack("c", hex($1))/ge;
			$fields{$temp1} = $temp2;
		}
	}

	if ($fields{force}) {
		$force = $fields{force};
	} else {
		$force = 0;
	}

	if ($force) {
		#opens the connection to the database
		$dbh = DBI->connect("dbi:mysql:$db_name:$db_ip", "$db_user", "$db_password") or die "Connection: $DBI::errstr";

$sth = $dbh->prepare(<<"__VIEW_LOGS__") or die "Preparing: ", $dbh->errstr;
	DELETE FROM logs
__VIEW_LOGS__

		$sth->execute or die "Executing: ", $sth->errstr;

		$sth->finish();
		$dbh->disconnect;

		# insert into teh table logs
		insert_logs($user, $date, "delete_logs", "", "Logs deleted!");

print qq {
	<br><p align="center"><i>LOGS DELETED!!!</i><br><p>
	<center>
	<form name="main">
		<input type="hidden" name="operacao" value="">
		<input type="submit" value="Voltar">
	</form>
	</center>
}

	} else {
		# insert into teh table logs
		insert_logs($user, $date, "delete_logs", "", "Delete logs?");
print qq {
	<br><p align="center"><i>TENS A CERTEZA?</i><br><p>
	<center>
	<form name="main">
		<input type="hidden" name="operacao" value="delete_logs">
		<input type="hidden" name="force" value="1">
		<input type="submit" value="Sim">
	</form>
	<form name="main">
		<input type="hidden" name="operacao" value="">
		<input type="submit" value="Nao">
	</form>
	</center>
}


	}
}

	
#############################################################
# Debug function
sub debug {
	my (%fields) = @_;
	
	foreach (sort keys %fields) {
		print "$_ : $fields{$_}<br>\n";
	}
}
